;@goto translate
;===============================================================================

.586P
.MODEL FLAT, STDCALL

 OPTION      CASEMAP :NONE


 INCLUDE     KERNEL32.INC
 INCLUDE     USER32.INC

 INCLUDELIB  KERNEL32.LIB
 INCLUDELIB  USER32.LIB

 UNICODE     = 0
 ARGUMENTS   = 0 
 INCLUDE     W32MAIN.INC

.586P

;===============================================================================
.DATA

     BCHK        =   "BCHK" ;change to the actual value

     ErrorSign   EQU -1     ;returns when Error occurs

     ReturnID    EQU 0FF01H ;returns on GetID

    ;Breakpoint registers
     BR_0        EQU 00
     BR_1        EQU 01
     BR_2        EQU 02
     BR_3        EQU 03

    ;Breakpoint hits
     BH_0        EQU 01
     BH_1        EQU 02
     BH_2        EQU 04
     BH_3        EQU 08

    ;Breakpoint types
     BT_EXECUTE  EQU 00
     BT_WRITE    EQU 01
     BT_IO       EQU 02
     BT_ACCESS   EQU 03

    ;Breakpoint lengths
     BL_BYTE     EQU 00
     BL_WORD     EQU 04
     BL_UNUSED   EQU 08
     BL_DWORD    EQU 12


;================================================================================
;    BCHK interface in SoftICE (v4.0) has 32/36 functions (9x/NT).
;    Here are some of them (my research):
;================================================================================
    GetID   = 0 
      ;IN:  -    
      ;OUT: EAX = ReturnID
;================================================================================
    DeactivateLowestBreakpoint = 8
      ;IN:  -  
      ;OUT: Success: EAX = BR_x  
      ;     Error:   EAX = ErrorSign if BR_x > 3 or all_deactivated
;================================================================================
    ActivateBreakpoint = 9
      ;IN:  BL = BR_x 
      ;OUT: Success: EAX = 0
      ;     Error:   EAX = ErrorSign if BR_x > 3 or already_activated
;================================================================================
    SetBreakpoint = 10
      ;IN:  BL = BR_x
      ;     BH = BT_x + BL_x
      ;     CX = Selector | Segment
      ;     EDX = Offset
      ;OUT: Success: EAX = 0
      ;     Error:   EAX = ErrorSign if BR_x > 3 or 
      ;                                 BT_x + BL_x > 15 or
      ;                                 invalid_selector or
      ;                                 breakpoint_active
;================================================================================
    ClearBreakpoint = 11
      ;IN:  BL = BR_x
      ;OUT: Success: EAX = 0
      ;     Error:   EAX = ErrorSign if BR_x > 3
;================================================================================
    GetBreakpointStatus = 12
      ;IN:  -
      ;OUT: EAX = DR6
;================================================================================
    ClearBreakpointStatus = 13
      ;IN:  BL = BR_x
      ;OUT: Success: EAX = 0
      ;     Error:   EAX = ErrorSign if BR_x > 3
;================================================================================
    xText            BYTE  "AutoDebug",0
    NotPresent       BYTE  "BCHK interface not present.",0
    GoodBreakpoint   BYTE  "Good breakpoint.",0
    BadBreakpoint    BYTE  "Bad breakpoint.",0

    IwasHere         BYTE  0
;===============================================================================
.CODE

 Start:
    ASSUME  FS:@data
    SUB     EAX, EAX
    CALL    There

    MOV     ECX, [ESP+12]   ;CONTEXT
    SUB     EAX, EAX
    INC     (CONTEXT PTR [ECX]).cx_Eip
    INC     IwasHere  
    RET

   There:
    PUSH    FS:[EAX]
    MOV     FS:[EAX], ESP

    MOV      AL, GetID
    MOV     EBP, BCHK
    INT       3
    NOP
    CMP     EAX, ReturnID
    MOV     EDX, OFFSET NotPresent
    JNE     Exitus


    ;standard situation is that all breakpoints are "active"

    SUB     EDI, EDI   ;Needs deactivate  = No
    MOV      AL, DeactivateLowestBreakpoint
    INT       3
    INC     EAX
    JE      @f
    DEC     EDI
    DEC     EAX
   @@:
    XCHG    EAX, EBX 

    MOV     ECX, CS
    MOV     EDX, OFFSET ThePlace
    MOV      BH, BT_EXECUTE + BL_BYTE
    MOV      AL, SetBreakpoint
    INT       3

    ;breakpoints don't need to be "activated" - they are still active
    ;but for sure:
    MOV      AL, ActivateBreakpoint
    INT       3

    NOP

   ThePlace:
    NOP

    MOV      AL, GetBreakpointStatus
    INT       3
    PUSH    EAX 

    MOV      AL, ClearBreakpoint
    INT       3
 
    INC     EDI  ;Needs deactivate?
    JE       @f
    MOV      AL, DeactivateLowestBreakpoint
    INT       3
   @@:

    POP     EAX
    MOV     EDX, OFFSET GoodBreakpoint
    SUB     EBP, EBP          ;allow bpx
    CMP     IwasHere, TRUE
    JNE      @f
    BSF     EAX, EAX
    CMP      AL,  BL
    JE      Exitus
   @@:
    MOV     EDX, OFFSET BadBreakpoint
   Exitus:
    SUB     EAX, EAX
    POP     FS:[EAX]
    POP     ECX
    INVOKE  MessageBox, EAX, EDX, ADDR xText, MB_ICONEXCLAMATION
    INVOKE  ExitProcess, 0

END Start

:translate
@echo off
ML /nologo /c /coff BCHKAPI.bat
LINK BCHKAPI.obj /nologo /SUBSYSTEM:WINDOWS /RELEASE /ALIGN:0X1000 /MERGE:.rdata=.text /MERGE:.data=.text /MERGE:.text=AutoDeb /SECTION:AutoDeb,REW /IGNORE:4078,4108
DEL BCHKAPI.obj