;@goto translate
;===============================================================================

.586P
.MODEL FLAT, STDCALL

 OPTION      CASEMAP :NONE

 INCLUDE     KERNEL32.INC
 INCLUDE     USER32.INC

 INCLUDELIB  KERNEL32.LIB
 INCLUDELIB  USER32.LIB

 UNICODE     = 0
 ARGUMENTS   = 0
 INCLUDE     W32MAIN.INC

;===============================================================================
.DATA

    EXCEPTION_RECORD		STRUCT
	ExceptionCode		DWORD ?
	ExceptionFlags		DWORD ?           
	EXCEPTION_RECORD_PTR	DWORD ?
	ExceptionAddress	DWORD ?
	NumberParameters	DWORD ?
	EXCEPTION_MAXIMUM_PARAMETERS  EQU 15  
	ExceptionInformation	DWORD EXCEPTION_MAXIMUM_PARAMETERS DUP (?)
    EXCEPTION_RECORD		ENDS

    xText     BYTE  "SoftICE detected via",0
    Method0   BYTE  "Nothing detected.",0
    Method1   BYTE  "Back Door Interface.",0
    Method2   BYTE  "Bounds Checker Interface.",0
    Method3   BYTE  "INT3 on UnhandledExceptionFilter.",0
    Method4   BYTE  "Changed IDT.",0

    NTICE     BYTE  "\\.\NTICE",0
    SIWVIDS   BYTE  "\\.\SIWVIDSTART",0
    SICE      BYTE  "\\.\SICE",0
    SIWVID    BYTE  "\\.\SIWVID",0

    Gate1DPL3 BYTE  FALSE

    Method5   BYTE  "Open "
              BYTE  SIZEOF SIWVIDS DUP (?)

;===============================================================================
.CODE

    MsgBox    PROTO :DWORD
    TestDriverPresence  PROTO :DWORD

 Start:

    ASSUME    FS:@data
    SUB       EAX, EAX
    PUSH      OFFSET xHandler
    PUSH      FS:[EAX]
    MOV       FS:[EAX], ESP

    MOV       EBX, EAX
    MOV        SI, 'FG'
    MOV        DI, 'JM'
    INT         3
    NOP

    CMP        SI, 'FG'
    JE         @f

    INVOKE    MsgBox, ADDR Method1

   @@:
    MOV        AL, 0
    MOV       EBP, 'BCHK'
    INT         3
    NOP

    SUB       EBP, EBP  ; I allow You bpx  because
                        ; "BCHK" in EBP causes ignoration of INT3 breakpoints
                        ; (when SoftICE isn't patched)
    CMP        AL, 0
    JE         @f

    INVOKE    MsgBox, ADDR Method2

   @@:
    MOV       EAX, DWORD PTR UnhandledExceptionFilter+2
    MOV       EAX, [EAX]
    CMP       BYTE PTR [EAX], 0CCH
    JNE       @f

    INVOKE    MsgBox, ADDR Method3

   @@:
    MOV       EAX, CS
    TEST       AL, 100B
    JNE       DOS9x

    INT         1
    NOP
    NOP
    CMP       Gate1DPL3, FALSE
    JE         @f
    JMP       CrystalMethod

   DOS9x:
    PUSH      EAX
    SIDT      [ESP-2]
    POP       ESI          ;ESI = IDT base

    INT3      = 8*03
    ADD       ESI, INT3    ;ESI = &INT3_descriptor

    INVOKE    IsBadReadPtr, ESI, 8*3
    TEST      EAX, EAX
    JNE       @f

    INT4      = 8*01
    INT5      = 8*02

    MOV       ECX, [ESI+4]
    MOV        CX, [ESI+0]
    MOV       EDX, [ESI+INT4+4]
    MOV        DX, [ESI+INT4]
    MOV       EAX, [ESI+INT5+4]
    MOV        AX, [ESI+INT5]
    SUB       EAX, EDX
    SUB       EDX, ECX
    SUB       EAX, EDX
    JE         @f

   CrystalMethod:
    INVOKE    MsgBox, ADDR Method4
    
   @@:
    INVOKE    TestDriverPresence, ADDR NTICE
    INVOKE    TestDriverPresence, ADDR SIWVIDS
    INVOKE    TestDriverPresence, ADDR SICE
    INVOKE    TestDriverPresence, ADDR SIWVID

    SUB       EAX, EAX
    POP       FS:[EAX]     ;restore old SEH
    POP       EAX          ;original ESP

    TEST      EBX, EBX
    JNE       @f
    INVOKE    MsgBox, ADDR Method0

   @@:
    INVOKE    ExitProcess, 0


   MsgBox     PROC  MsgAddr
    INC       EBX
    INVOKE    MessageBox, NULL, MsgAddr, ADDR xText, MB_ICONEXCLAMATION
    RET
   MsgBox     ENDP


   xHandler   PROC C, ExcInfo, xFrame, xContext, xDispContext
    MOV       EAX, ExcInfo
    MOV       ECX, xContext
    ADD       ECX, CONTEXT.cx_Eip
    MOV       EAX, (EXCEPTION_RECORD PTR [EAX]).ExceptionCode
    INC       DWORD PTR [ECX]
    SUB       EAX, STATUS_BREAKPOINT
    JE         @f
    INC       DWORD PTR [ECX]
    DEC       EAX
    JNE        @f
    INC       Gate1DPL3
   @@:
    SUB       EAX, EAX
    RET
   xHandler   ENDP

   TestDriverPresence PROC DriverName
    MOV       EDI, DriverName
    INVOKE    CreateFileA, EDI, GENERIC_READ, FILE_SHARE_READ,\
                           0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
    INC       EAX
    JE         @f
    DEC       EAX
    INVOKE    CloseHandle, EAX
    MOV       ESI, OFFSET Method5
    MOV       BYTE PTR [ESI+SIZEOF Method5], 0
    INVOKE    lstrcat, ESI, EDI
    INVOKE    MsgBox, ESI
   @@:
    RET     
   TestDriverPresence ENDP


END Start

:translate
@echo off
ML /nologo /c /coff DetectSoftICE.bat
LINK DetectSoftICE.obj /nologo /SUBSYSTEM:WINDOWS /RELEASE /ALIGN:0X1000 /MERGE:.rdata=.text /MERGE:.data=.text /MERGE:.text=Detect /SECTION:Detect,RWE /IGNORE:4078,4108
DEL DetectSoftICE.obj
