;@goto translate


.586P

.MODEL            FLAT, STDCALL

   OPTION         CASEMAP: NONE

   UNICODE        = 1
   ARGUMENTS      = 0
   INCLUDE        W32Main.inc
   INCLUDE        APIMACRO.mac

   INCLUDELIB     iKERNEL32.lib
   INCLUDELIB     iUSER32.lib


.DATA?

   MEMORY_BASIC_INFORMATION STRUCT
     BaseAddress       DWORD    ?
     AllocationBase    DWORD    ?
     AllocationProtect DWORD    ?
     RegionSize        DWORD    ?
     State             DWORD    ?
     Protect           DWORD    ?
     lType             DWORD    ?
   MEMORY_BASIC_INFORMATION ENDS

   mbi            MEMORY_BASIC_INFORMATION <>
   GuardPageFault BYTE          ?  ;0 automatically

   ExceptionContinueExecution	EQU 0
   ExceptionContinueSearch	EQU 1


.CODE

   TEXT           MACRO __Nomen,  __Text
                  ALIGN 4
                  __Nomen LABEL CHAR
                  STRING  __Text
                  ENDM

   TEXT           sTitle,        <Guard Page Test/0>
    COMMENT $
   TEXT           AllocFailed,   <VirtualAlloc failed/:/0>
   TEXT           FreeFailed,    <VirtualFree  failed/:/0>
END COMMENT $
   TEXT           QueryFailed,   <VirtualQuery failed/:/0>
   TEXT           ProtectFailed, <VirtualProtect failed/:/0>
   TEXT           GuardFault,    <Guard page works/:/0>
   TEXT           NoGuardFault,  <Nothing happened/:/0>

 Start:
   ASSUME    FS:NOTHING

   CALL      MakexFrame

  xHandler   PROC
   MOV       ECX, [ESP+4]                                   ;EXCEPTION_RECORD
   MOV       EAX, ExceptionContinueSearch
   CMP       DWORD PTR [ECX], STATUS_GUARD_PAGE_VIOLATION   ;ExceptionCode
   JNE       @F
   MOV       EAX, ExceptionContinueExecution
   INC       GuardPageFault
  @@:
   RET
  xHandler   ENDP

  MakexFrame:
   PUSH      FS:0
   MOV       FS:0, ESP

COMMENT      /*
   cbSize    = 4096
   iWin32    VirtualAlloc, NULL, cbSize, MEM_COMMIT, PAGE_READWRITE OR PAGE_GUARD
   TEST      EAX, EAX
   MOV       ECX, OFFSET AllocFailed
   JE        Msg

   MOV        DL, [EAX]

   iWin32    VirtualFree, EAX, NULL, MEM_RELEASE
   TEST      EAX, EAX
   MOV       ECX, OFFSET FreeFailed
   JE        Msg
             */

   iWin32    GetModuleHandleW, NULL 
   MOV       EDI, EAX          	;headers
   MOV       ESI, OFFSET mbi
   ASSUME    ESI: PTR MEMORY_BASIC_INFORMATION
   iWin32    VirtualQuery, EAX, ESI, SIZEOF mbi
   TEST      EAX, EAX
   MOV       ECX, OFFSET QueryFailed
   JE        Msg

   MOV       EAX, [ESI].Protect
   PUSH      EDX
   OR        EAX, PAGE_GUARD
   iWin32    VirtualProtect, EDI, 1000H, EAX, ESP
   TEST      EAX, EAX
   POP       EBX                ;orig settings
   MOV       ECX, OFFSET ProtectFailed
   JE        Msg

   MOV       AL,  [EDI]   ;GUARD_PAGE_VIOLATION

   DEC       GuardPageFault
   MOV       ECX, OFFSET GuardFault
   JNS       Msg
   MOV       ECX, OFFSET NoGuardFault
  Msg:
   POP       FS:0
   POP       EAX 
   iWin32    MessageBoxW, NULL, ECX, OFFSET sTitle, MB_ICONINFORMATION
   iWin32    ExitProcess, STATUS_SUCCESS

END Start

:translate
@echo off
ML   /c /coff /nologo GuardPage.bat
LINK GuardPage /nologo /ALIGN:0X1000 /SUBSYSTEM:WINDOWS /RELEASE /MERGE:.rdata=.text /BASE:0X02890000 /IGNORE:4108,4078
DEL  GuardPage.obj
