COMMENT $

#define WDBGAPI __stdcall

typedef
VOID                                       Displays info in KD
(WDBGAPI*PWINDBG_OUTPUT_ROUTINE)(          this is the most used routine
    PCSTR lpFormat,                        and most important
    ...                                    it's the principle of extensions
    );                                     C calling convention
                                           parameters the same as for printf
                                           CR,LF == 0AH
typedef
ULONG                                      (usually) returns address of symbol
(WDBGAPI*PWINDBG_GET_EXPRESSION)(          this is often used routine
    PCSTR lpExpression
    );

typedef
VOID
(WDBGAPI*PWINDBG_GET_SYMBOL)(              not so often used
    PVOID   offset,
    PUCHAR  pchBuffer,
    PULONG  pDisplacement
    );

typedef
ULONG
(WDBGAPI*PWINDBG_DISASM)(                  not so often used
    PULONG lpOffset,
    PCSTR  lpBuffer,
    ULONG  fShowEffectiveAddress
    );

typedef
ULONG
(WDBGAPI*PWINDBG_CHECK_CONTROL_C)(         used to stop displaying
    VOID                                   of huge texts (like in debug)
    );

typedef
ULONG
(WDBGAPI*PWINDBG_READ_PROCESS_MEMORY_ROUTINE)(
    ULONG  offset,
    PVOID  lpBuffer,
    ULONG  cb,
    PULONG lpcbBytesRead
    );

typedef
ULONG
(WDBGAPI*PWINDBG_WRITE_PROCESS_MEMORY_ROUTINE)(
    ULONG   offset,
    LPCVOID lpBuffer,
    ULONG   cb,
    PULONG  lpcbBytesWritten
    );

typedef
ULONG
(WDBGAPI*PWINDBG_GET_THREAD_CONTEXT_ROUTINE)(
    ULONG       Processor,
    PCONTEXT    lpContext,
    ULONG       cbSizeOfContext
    );

typedef
ULONG
(WDBGAPI*PWINDBG_SET_THREAD_CONTEXT_ROUTINE)(
    ULONG       Processor,
    PCONTEXT    lpContext,
    ULONG       cbSizeOfContext
    );

typedef
ULONG
(WDBGAPI*PWINDBG_IOCTL_ROUTINE)(           see IG ioctls below
    USHORT   IoctlType,
    PVOID    lpvData,
    ULONG    cbSize
    );


typedef
ULONG
(*PWINDBG_STACKTRACE_ROUTINE)(
    ULONG             FramePointer,
    ULONG             StackPointer,
    ULONG             ProgramCounter,
    PEXTSTACKTRACE    StackFrames,
    ULONG             Frames
    );

$   ;End COMMENT

EXTSTACKTRACE         STRUCT
    FramePointer      DWORD ? 
    ProgramCounter    DWORD ? 
    ReturnAddress     DWORD ? 
    Args              DWORD 4 DUP (?) 
EXTSTACKTRACE         ENDS  

WINDBG_EXTENSION_APIS STRUCT
    nSize                        DWORD ?;  ULONG      = 30H
    lpOutputRoutine              DWORD ?;  PWINDBG_OUTPUT_ROUTINE              
    lpGetExpressionRoutine       DWORD ?;  PWINDBG_GET_EXPRESSION              
    lpGetSymbolRoutine           DWORD ?;  PWINDBG_GET_SYMBOL                  
    lpDisasmRoutine              DWORD ?;  PWINDBG_DISASM                      
    lpCheckControlCRoutine       DWORD ?;  PWINDBG_CHECK_CONTROL_C             
    lpReadProcessMemoryRoutine   DWORD ?;  PWINDBG_READ_PROCESS_MEMORY_ROUTINE 
    lpWriteProcessMemoryRoutine  DWORD ?;  PWINDBG_WRITE_PROCESS_MEMORY_ROUTINE
    lpGetThreadContextRoutine    DWORD ?;  PWINDBG_GET_THREAD_CONTEXT_ROUTINE  
    lpSetThreadContextRoutine    DWORD ?;  PWINDBG_SET_THREAD_CONTEXT_ROUTINE  
    lpIoctlRoutine               DWORD ?;  PWINDBG_IOCTL_ROUTINE               
    lpStackTraceRoutine          DWORD ?;  PWINDBG_STACKTRACE_ROUTINE          
WINDBG_EXTENSION_APIS ENDS

COMMENT  $
typedef
VOID
(WDBGAPI*PWINDBG_EXTENSION_ROUTINE)(
    HANDLE                  hCurrentProcess,
    HANDLE                  hCurrentThread,
    ULONG                   dwCurrentPc,
    ULONG                   dwProcessor,
    PCSTR                   lpArgumentString
    );

typedef
VOID
(WDBGAPI*PWINDBG_EXTENSION_DLL_INIT)(
    PWINDBG_EXTENSION_APIS lpExtensionApis,
    USHORT                 MajorVersion,
    USHORT                 MinorVersion
    );

typedef
ULONG
(WDBGAPI*PWINDBG_CHECK_VERSION)(
    VOID
    );

typedef
LPEXT_API_VERSION
(WDBGAPI*PWINDBG_EXTENSION_API_VERSION)(
    VOID
    );

$   ;End COMMENT

EXT_API_VERSION_NUMBER  EQU  4

EXT_API_VERSION         STRUCT
    MajorVersion        WORD ?
    MinorVersion        WORD ?
    Revision            WORD ?
    Reserved            WORD ?
EXT_API_VERSION         ENDS

IG_KD_CONTEXT           EQU 01
IG_READ_CONTROL_SPACE   EQU 02
IG_WRITE_CONTROL_SPACE  EQU 03
IG_READ_IO_SPACE        EQU 04
IG_WRITE_IO_SPACE       EQU 05
IG_READ_PHYSICAL        EQU 06
IG_WRITE_PHYSICAL       EQU 07
IG_READ_IO_SPACE_EX     EQU 08
IG_WRITE_IO_SPACE_EX    EQU 09
IG_KSTACK_HELP          EQU 10 ;obsolete
IG_SET_THREAD           EQU 11
IG_READ_MSR             EQU 12
IG_WRITE_MSR            EQU 13
IG_GET_DEBUGGER_DATA    EQU 14
IG_GET_KERNEL_VERSION   EQU 15
IG_RELOAD_SYMBOLS       EQU 16
IG_GET_SET_SYMPATH      EQU 17
IG_GET_EXCEPTION_RECORD EQU 18



PROCESSORINFO           STRUCT   ;for IG_KD_CONTEXT
    Processor           WORD ?   ;current processor
    NumberProcessors    WORD ?   ;total number of processors
PROCESSORINFO           ENDS

READCONTROLSPACE        STRUCT
    Processor           WORD  ?    
    Address             DWORD ?    
    BufLen              DWORD ?    
    Buf                 WORD  ?  ;UCHAR 
READCONTROLSPACE        ENDS

IOSPACE                 STRUCT
    Address             DWORD ?
    Length_             DWORD ?  ;1, 2, or 4 bytes
    Data                DWORD ?
IOSPACE                 ENDS

IOSPACE_EX              STRUCT
    Address             DWORD ?
    Length_             DWORD ?  ;1, 2, or 4 bytes
    Data                DWORD ?
    InterfaceType       DWORD ?
    BusNumber           DWORD ?
    AddressSpace        DWORD ?
IOSPACE_EX              ENDS

PHYSICAL                STRUCT
    Address             DWORD ?  ;LARGE_INTEGER     
    BufLen              DWORD ?
    Buf                 WORD  ?  ;UCHAR             
PHYSICAL                ENDS


READ_WRITE_MSR          STRUCT  
    Msr                 DWORD ?
    Value               QWORD ?
READ_WRITE_MSR          ENDS

 
GET_SET_SYMPATH         STRUCT
    Args                DWORD ?   ;args to !reload command 
    Result              DWORD ?   ;returns new path 
   _Length              DWORD ?   ;Length of result buffer  or WORD ?
GET_SET_SYMPATH         ENDS 


COMMENT  $
 
#define DECLARE_API(s)                             \ 
    CPPMOD VOID                                    \ 
    s(                                             \ 
        HANDLE                 hCurrentProcess,    \ 
        HANDLE                 hCurrentThread,     \ 
        ULONG                  dwCurrentPc,        \ 
        ULONG                  dwProcessor,        \ 
        PCSTR                  args                \ 
     ) 
 
#ifndef NOEXTAPI 
 
#define dprintf          (ExtensionApis.lpOutputRoutine) 
#define GetExpression    (ExtensionApis.lpGetExpressionRoutine) 
#define GetSymbol        (ExtensionApis.lpGetSymbolRoutine) 
#define Disassm          (ExtensionApis.lpDisasmRoutine) 
#define CheckControlC    (ExtensionApis.lpCheckControlCRoutine) 
#define ReadMemory       (ExtensionApis.lpReadProcessMemoryRoutine) 
#define WriteMemory      (ExtensionApis.lpWriteProcessMemoryRoutine) 
#define GetContext       (ExtensionApis.lpGetThreadContextRoutine) 
#define SetContext       (ExtensionApis.lpSetThreadContextRoutine) 
#define Ioctl            (ExtensionApis.lpIoctlRoutine) 
#define StackTrace       (ExtensionApis.lpStackTraceRoutine) 
 
 
#define GetKdContext(ppi) \ 
    Ioctl( IG_KD_CONTEXT, (PVOID)ppi, sizeof(*ppi) ) 
 
// 
// BOOL 
// GetDebuggerData( 
//     ULONG Tag, 
//     PVOID Buf, 
//     ULONG Size 
//     ) 
// 
/*++ 
 
Routine Description: 
 
 
 
Arguments: 
 
 
 
Return Value: 
 
 
 
--*/ 
 
#define GetDebuggerData(TAG, BUF, SIZE)                             \ 
      ( (((PDBGKD_DEBUG_DATA_HEADER)(BUF))->OwnerTag = (TAG)),      \ 
        (((PDBGKD_DEBUG_DATA_HEADER)(BUF))->Size = (SIZE)),         \ 
        Ioctl( IG_GET_DEBUGGER_DATA, (PVOID)(BUF), (SIZE) ) ) 
 
extern WINDBG_EXTENSION_APIS ExtensionApis; 
 
__inline VOID 
ReadControlSpace( 
    USHORT  processor, 
    ULONG   address, 
    PVOID   buf, 
    ULONG   size 
    ) 
{ 
    PREADCONTROLSPACE prc; 
    prc = (PREADCONTROLSPACE)LocalAlloc(LPTR, sizeof(*prc) + size ); 
    ZeroMemory( prc->Buf, size ); 
    prc->Processor = processor; 
    prc->Address = (ULONG)address; 
    prc->BufLen = size; 
    Ioctl( IG_READ_CONTROL_SPACE, (PVOID)prc, sizeof(*prc) + size ); 
    CopyMemory( buf, prc->Buf, size ); 
    LocalFree( prc ); 
} 
 
__inline VOID 
ReadIoSpace( 
    ULONG   address, 
    PULONG  data, 
    PULONG  size 
    ) 
{ 
    IOSPACE is; 
    is.Address = (ULONG)address; 
    is.Length = *size; 
    Ioctl( IG_READ_IO_SPACE, (PVOID)&is, sizeof(is) ); 
    memcpy(data, &is.Data, is.Length); 
    *size = is.Length; 
} 
 
__inline VOID 
WriteIoSpace( 
    ULONG   address, 
    ULONG   data, 
    PULONG  size 
    ) 
{ 
    IOSPACE is; 
    is.Address = (ULONG)address; 
    is.Length = *size; 
    is.Data = data; 
    Ioctl( IG_WRITE_IO_SPACE, (PVOID)&is, sizeof(is) ); 
    *size = is.Length; 
} 
 
__inline VOID 
ReadIoSpaceEx( 
    ULONG   address, 
    PULONG  data, 
    PULONG  size, 
    ULONG   interfacetype, 
    ULONG   busnumber, 
    ULONG   addressspace 
    ) 
{ 
    IOSPACE_EX is; 
    is.Address = (ULONG)address; 
    is.Length = *size; 
    is.Data = 0; 
    is.InterfaceType = interfacetype; 
    is.BusNumber = busnumber; 
    is.AddressSpace = addressspace; 
    Ioctl( IG_READ_IO_SPACE_EX, (PVOID)&is, sizeof(is) ); 
    *data = is.Data; 
    *size = is.Length; 
} 
 
__inline VOID 
WriteIoSpaceEx( 
    ULONG   address, 
    ULONG   data, 
    PULONG  size, 
    ULONG   interfacetype, 
    ULONG   busnumber, 
    ULONG   addressspace 
    ) 
{ 
    IOSPACE_EX is; 
    is.Address = (ULONG)address; 
    is.Length = *size; 
    is.Data = data; 
    is.InterfaceType = interfacetype; 
    is.BusNumber = busnumber; 
    is.AddressSpace = addressspace; 
    Ioctl( IG_WRITE_IO_SPACE_EX, (PVOID)&is, sizeof(is) ); 
    *size = is.Length; 
} 
 
__inline VOID 
ReadPhysical( 
    LARGE_INTEGER       address, 
    PVOID               buf, 
    ULONG               size, 
    PULONG              sizer 
    ) 
{ 
    PPHYSICAL phy; 
    phy = (PPHYSICAL)LocalAlloc(LPTR,  sizeof(*phy) + size ); 
    ZeroMemory( phy->Buf, size ); 
    phy->Address = address; 
    phy->BufLen = size; 
    Ioctl( IG_READ_PHYSICAL, (PVOID)phy, sizeof(*phy) + size ); 
    *sizer = phy->BufLen; 
    CopyMemory( buf, phy->Buf, *sizer ); 
    LocalFree( phy ); 
} 
 
__inline VOID 
WritePhysical( 
    LARGE_INTEGER       address, 
    PVOID               buf, 
    ULONG               size, 
    PULONG              sizew 
    ) 
{ 
    PPHYSICAL phy; 
    phy = (PPHYSICAL)LocalAlloc(LPTR, sizeof(*phy) + size ); 
    ZeroMemory( phy->Buf, size ); 
    phy->Address = address; 
    phy->BufLen = size; 
    CopyMemory( phy->Buf, buf, size ); 
    Ioctl( IG_WRITE_PHYSICAL, (PVOID)phy, sizeof(*phy) + size ); 
    *sizew = phy->BufLen; 
    LocalFree( phy ); 
} 
 
__inline VOID 
SetThreadForOperation( 
    PULONG Thread 
    ) 
{ 
    Ioctl(IG_SET_THREAD, (PVOID)Thread, sizeof(ULONG)); 
} 
 
__inline VOID 
ReadMsr( 
    ULONG       MsrReg, 
    ULONGLONG   *MsrValue 
    ) 
{ 
    PREAD_WRITE_MSR msr; 
    LARGE_INTEGER li; 
 
    msr = (PREAD_WRITE_MSR)LocalAlloc(LPTR,  sizeof(*msr)); 
    msr->Msr = MsrReg; 
    Ioctl( IG_READ_MSR, (PVOID)msr, sizeof(*msr) ); 
 
    *MsrValue = msr->Value; 
    LocalFree( msr ); 
} 
 
__inline VOID 
WriteMsr( 
    ULONG       MsrReg, 
    ULONGLONG   MsrValue 
    ) 
{ 
    PREAD_WRITE_MSR msr; 
 
    msr = (PREAD_WRITE_MSR)LocalAlloc(LPTR,  sizeof(*msr)); 
    msr->Msr = MsrReg; 
    msr->Value = MsrValue; 
    Ioctl( IG_WRITE_MSR, (PVOID)msr, sizeof(*msr) ); 
    LocalFree( msr ); 
} 
 
__inline VOID 
ReloadSymbols( 
    IN PSTR Arg OPTIONAL 
    ) 
/*++ 
 
Routine Description: 
 
    Calls the debugger to reload symbols. 
 

Arguments: 
 
    Args - Supplies the tail of a !reload command string. 
 
        !reload [flags] [module[=address]] 
        flags:   /n  do not load from usermode list 
                 /u  unload symbols, no reload 
                 /v  verbose 
 
        A value of NULL is equivalent to an empty string 
 
Return Value: 
 
    None 
 
--*/ 
{ 
    Ioctl(IG_RELOAD_SYMBOLS, (PVOID)Arg, Arg?(strlen(Arg)+1):0); 
} 
 
__inline VOID 
GetSetSympath( 
    IN PSTR Arg, 
    OUT PSTR Result OPTIONAL, 
    IN int Length 
    ) 
/*++ 
 
Routine Description: 
 
    Calls the debugger to set or retrieve symbol search path. 
 
Arguments: 
 
    Arg - Supplies new search path.  If Arg is NULL or string is empty, 
            the search path is not changed and the current setting is 
            returned in Result.  When the symbol search path is changed, 
            a call to ReloadSymbols is made implicitly. 
 
    Result - OPTIONAL Returns the symbol search path setting. 
 
    Length - Supplies the size of the buffer supplied by Result. 
 
Return Value: 
 
    None 
 
--*/ 
{ 
    GET_SET_SYMPATH gss; 
    gss.Args = Arg; 
    gss.Result = Result; 
    gss.Length = Length; 
    Ioctl(IG_GET_SET_SYMPATH, (PVOID)&gss, sizeof(gss)); 
} 
 
 
     $